package com.chinaitop.depot.intelligent.basicdata.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TWarehouseExample {
    /**
     * t_warehouse
     */
    protected String orderByClause;

    /**
     * t_warehouse
     */
    protected boolean distinct;

    /**
     * t_warehouse
     */
    protected List<Criteria> oredCriteria;

    public TWarehouseExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_warehouse 2018-12-14
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andVKdCodeIsNull() {
            addCriterion("v_kd_code is null");
            return (Criteria) this;
        }

        public Criteria andVKdCodeIsNotNull() {
            addCriterion("v_kd_code is not null");
            return (Criteria) this;
        }

        public Criteria andVKdCodeEqualTo(String value) {
            addCriterion("v_kd_code =", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeNotEqualTo(String value) {
            addCriterion("v_kd_code <>", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeGreaterThan(String value) {
            addCriterion("v_kd_code >", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_kd_code >=", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeLessThan(String value) {
            addCriterion("v_kd_code <", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeLessThanOrEqualTo(String value) {
            addCriterion("v_kd_code <=", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeLike(String value) {
            addCriterion("v_kd_code like", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeNotLike(String value) {
            addCriterion("v_kd_code not like", value, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeIn(List<String> values) {
            addCriterion("v_kd_code in", values, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeNotIn(List<String> values) {
            addCriterion("v_kd_code not in", values, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeBetween(String value1, String value2) {
            addCriterion("v_kd_code between", value1, value2, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVKdCodeNotBetween(String value1, String value2) {
            addCriterion("v_kd_code not between", value1, value2, "vKdCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfNameIsNull() {
            addCriterion("v_cf_name is null");
            return (Criteria) this;
        }

        public Criteria andVCfNameIsNotNull() {
            addCriterion("v_cf_name is not null");
            return (Criteria) this;
        }

        public Criteria andVCfNameEqualTo(String value) {
            addCriterion("v_cf_name =", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameNotEqualTo(String value) {
            addCriterion("v_cf_name <>", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameGreaterThan(String value) {
            addCriterion("v_cf_name >", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_name >=", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameLessThan(String value) {
            addCriterion("v_cf_name <", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameLessThanOrEqualTo(String value) {
            addCriterion("v_cf_name <=", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameLike(String value) {
            addCriterion("v_cf_name like", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameNotLike(String value) {
            addCriterion("v_cf_name not like", value, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameIn(List<String> values) {
            addCriterion("v_cf_name in", values, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameNotIn(List<String> values) {
            addCriterion("v_cf_name not in", values, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameBetween(String value1, String value2) {
            addCriterion("v_cf_name between", value1, value2, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfNameNotBetween(String value1, String value2) {
            addCriterion("v_cf_name not between", value1, value2, "vCfName");
            return (Criteria) this;
        }

        public Criteria andVCfTypeIsNull() {
            addCriterion("v_cf_type is null");
            return (Criteria) this;
        }

        public Criteria andVCfTypeIsNotNull() {
            addCriterion("v_cf_type is not null");
            return (Criteria) this;
        }

        public Criteria andVCfTypeEqualTo(String value) {
            addCriterion("v_cf_type =", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeNotEqualTo(String value) {
            addCriterion("v_cf_type <>", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeGreaterThan(String value) {
            addCriterion("v_cf_type >", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_type >=", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeLessThan(String value) {
            addCriterion("v_cf_type <", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_type <=", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeLike(String value) {
            addCriterion("v_cf_type like", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeNotLike(String value) {
            addCriterion("v_cf_type not like", value, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeIn(List<String> values) {
            addCriterion("v_cf_type in", values, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeNotIn(List<String> values) {
            addCriterion("v_cf_type not in", values, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeBetween(String value1, String value2) {
            addCriterion("v_cf_type between", value1, value2, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfTypeNotBetween(String value1, String value2) {
            addCriterion("v_cf_type not between", value1, value2, "vCfType");
            return (Criteria) this;
        }

        public Criteria andVCfStructIsNull() {
            addCriterion("v_cf_struct is null");
            return (Criteria) this;
        }

        public Criteria andVCfStructIsNotNull() {
            addCriterion("v_cf_struct is not null");
            return (Criteria) this;
        }

        public Criteria andVCfStructEqualTo(String value) {
            addCriterion("v_cf_struct =", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructNotEqualTo(String value) {
            addCriterion("v_cf_struct <>", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructGreaterThan(String value) {
            addCriterion("v_cf_struct >", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_struct >=", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructLessThan(String value) {
            addCriterion("v_cf_struct <", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructLessThanOrEqualTo(String value) {
            addCriterion("v_cf_struct <=", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructLike(String value) {
            addCriterion("v_cf_struct like", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructNotLike(String value) {
            addCriterion("v_cf_struct not like", value, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructIn(List<String> values) {
            addCriterion("v_cf_struct in", values, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructNotIn(List<String> values) {
            addCriterion("v_cf_struct not in", values, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructBetween(String value1, String value2) {
            addCriterion("v_cf_struct between", value1, value2, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVCfStructNotBetween(String value1, String value2) {
            addCriterion("v_cf_struct not between", value1, value2, "vCfStruct");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeIsNull() {
            addCriterion("v_build_type is null");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeIsNotNull() {
            addCriterion("v_build_type is not null");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeEqualTo(String value) {
            addCriterion("v_build_type =", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeNotEqualTo(String value) {
            addCriterion("v_build_type <>", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeGreaterThan(String value) {
            addCriterion("v_build_type >", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeGreaterThanOrEqualTo(String value) {
            addCriterion("v_build_type >=", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeLessThan(String value) {
            addCriterion("v_build_type <", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeLessThanOrEqualTo(String value) {
            addCriterion("v_build_type <=", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeLike(String value) {
            addCriterion("v_build_type like", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeNotLike(String value) {
            addCriterion("v_build_type not like", value, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeIn(List<String> values) {
            addCriterion("v_build_type in", values, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeNotIn(List<String> values) {
            addCriterion("v_build_type not in", values, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeBetween(String value1, String value2) {
            addCriterion("v_build_type between", value1, value2, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVBuildTypeNotBetween(String value1, String value2) {
            addCriterion("v_build_type not between", value1, value2, "vBuildType");
            return (Criteria) this;
        }

        public Criteria andVCfLongIsNull() {
            addCriterion("v_cf_long is null");
            return (Criteria) this;
        }

        public Criteria andVCfLongIsNotNull() {
            addCriterion("v_cf_long is not null");
            return (Criteria) this;
        }

        public Criteria andVCfLongEqualTo(BigDecimal value) {
            addCriterion("v_cf_long =", value, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongNotEqualTo(BigDecimal value) {
            addCriterion("v_cf_long <>", value, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongGreaterThan(BigDecimal value) {
            addCriterion("v_cf_long >", value, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("v_cf_long >=", value, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongLessThan(BigDecimal value) {
            addCriterion("v_cf_long <", value, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongLessThanOrEqualTo(BigDecimal value) {
            addCriterion("v_cf_long <=", value, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongIn(List<BigDecimal> values) {
            addCriterion("v_cf_long in", values, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongNotIn(List<BigDecimal> values) {
            addCriterion("v_cf_long not in", values, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_cf_long between", value1, value2, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfLongNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_cf_long not between", value1, value2, "vCfLong");
            return (Criteria) this;
        }

        public Criteria andVCfWideIsNull() {
            addCriterion("v_cf_wide is null");
            return (Criteria) this;
        }

        public Criteria andVCfWideIsNotNull() {
            addCriterion("v_cf_wide is not null");
            return (Criteria) this;
        }

        public Criteria andVCfWideEqualTo(BigDecimal value) {
            addCriterion("v_cf_wide =", value, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideNotEqualTo(BigDecimal value) {
            addCriterion("v_cf_wide <>", value, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideGreaterThan(BigDecimal value) {
            addCriterion("v_cf_wide >", value, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("v_cf_wide >=", value, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideLessThan(BigDecimal value) {
            addCriterion("v_cf_wide <", value, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideLessThanOrEqualTo(BigDecimal value) {
            addCriterion("v_cf_wide <=", value, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideIn(List<BigDecimal> values) {
            addCriterion("v_cf_wide in", values, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideNotIn(List<BigDecimal> values) {
            addCriterion("v_cf_wide not in", values, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_cf_wide between", value1, value2, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfWideNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_cf_wide not between", value1, value2, "vCfWide");
            return (Criteria) this;
        }

        public Criteria andVCfHighIsNull() {
            addCriterion("v_cf_high is null");
            return (Criteria) this;
        }

        public Criteria andVCfHighIsNotNull() {
            addCriterion("v_cf_high is not null");
            return (Criteria) this;
        }

        public Criteria andVCfHighEqualTo(BigDecimal value) {
            addCriterion("v_cf_high =", value, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighNotEqualTo(BigDecimal value) {
            addCriterion("v_cf_high <>", value, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighGreaterThan(BigDecimal value) {
            addCriterion("v_cf_high >", value, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("v_cf_high >=", value, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighLessThan(BigDecimal value) {
            addCriterion("v_cf_high <", value, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighLessThanOrEqualTo(BigDecimal value) {
            addCriterion("v_cf_high <=", value, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighIn(List<BigDecimal> values) {
            addCriterion("v_cf_high in", values, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighNotIn(List<BigDecimal> values) {
            addCriterion("v_cf_high not in", values, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_cf_high between", value1, value2, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andVCfHighNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_cf_high not between", value1, value2, "vCfHigh");
            return (Criteria) this;
        }

        public Criteria andFDesignCapIsNull() {
            addCriterion("f_design_cap is null");
            return (Criteria) this;
        }

        public Criteria andFDesignCapIsNotNull() {
            addCriterion("f_design_cap is not null");
            return (Criteria) this;
        }

        public Criteria andFDesignCapEqualTo(BigDecimal value) {
            addCriterion("f_design_cap =", value, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapNotEqualTo(BigDecimal value) {
            addCriterion("f_design_cap <>", value, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapGreaterThan(BigDecimal value) {
            addCriterion("f_design_cap >", value, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("f_design_cap >=", value, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapLessThan(BigDecimal value) {
            addCriterion("f_design_cap <", value, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapLessThanOrEqualTo(BigDecimal value) {
            addCriterion("f_design_cap <=", value, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapIn(List<BigDecimal> values) {
            addCriterion("f_design_cap in", values, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapNotIn(List<BigDecimal> values) {
            addCriterion("f_design_cap not in", values, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_design_cap between", value1, value2, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFDesignCapNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_design_cap not between", value1, value2, "fDesignCap");
            return (Criteria) this;
        }

        public Criteria andFActCapIsNull() {
            addCriterion("f_act_cap is null");
            return (Criteria) this;
        }

        public Criteria andFActCapIsNotNull() {
            addCriterion("f_act_cap is not null");
            return (Criteria) this;
        }

        public Criteria andFActCapEqualTo(BigDecimal value) {
            addCriterion("f_act_cap =", value, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapNotEqualTo(BigDecimal value) {
            addCriterion("f_act_cap <>", value, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapGreaterThan(BigDecimal value) {
            addCriterion("f_act_cap >", value, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("f_act_cap >=", value, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapLessThan(BigDecimal value) {
            addCriterion("f_act_cap <", value, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapLessThanOrEqualTo(BigDecimal value) {
            addCriterion("f_act_cap <=", value, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapIn(List<BigDecimal> values) {
            addCriterion("f_act_cap in", values, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapNotIn(List<BigDecimal> values) {
            addCriterion("f_act_cap not in", values, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_act_cap between", value1, value2, "fActCap");
            return (Criteria) this;
        }

        public Criteria andFActCapNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_act_cap not between", value1, value2, "fActCap");
            return (Criteria) this;
        }

        public Criteria andVWorkDateIsNull() {
            addCriterion("v_work_date is null");
            return (Criteria) this;
        }

        public Criteria andVWorkDateIsNotNull() {
            addCriterion("v_work_date is not null");
            return (Criteria) this;
        }

        public Criteria andVWorkDateEqualTo(Date value) {
            addCriterion("v_work_date =", value, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateNotEqualTo(Date value) {
            addCriterion("v_work_date <>", value, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateGreaterThan(Date value) {
            addCriterion("v_work_date >", value, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateGreaterThanOrEqualTo(Date value) {
            addCriterion("v_work_date >=", value, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateLessThan(Date value) {
            addCriterion("v_work_date <", value, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateLessThanOrEqualTo(Date value) {
            addCriterion("v_work_date <=", value, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateIn(List<Date> values) {
            addCriterion("v_work_date in", values, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateNotIn(List<Date> values) {
            addCriterion("v_work_date not in", values, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateBetween(Date value1, Date value2) {
            addCriterion("v_work_date between", value1, value2, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVWorkDateNotBetween(Date value1, Date value2) {
            addCriterion("v_work_date not between", value1, value2, "vWorkDate");
            return (Criteria) this;
        }

        public Criteria andVCfStatusIsNull() {
            addCriterion("v_cf_status is null");
            return (Criteria) this;
        }

        public Criteria andVCfStatusIsNotNull() {
            addCriterion("v_cf_status is not null");
            return (Criteria) this;
        }

        public Criteria andVCfStatusEqualTo(String value) {
            addCriterion("v_cf_status =", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusNotEqualTo(String value) {
            addCriterion("v_cf_status <>", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusGreaterThan(String value) {
            addCriterion("v_cf_status >", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_status >=", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusLessThan(String value) {
            addCriterion("v_cf_status <", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusLessThanOrEqualTo(String value) {
            addCriterion("v_cf_status <=", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusLike(String value) {
            addCriterion("v_cf_status like", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusNotLike(String value) {
            addCriterion("v_cf_status not like", value, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusIn(List<String> values) {
            addCriterion("v_cf_status in", values, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusNotIn(List<String> values) {
            addCriterion("v_cf_status not in", values, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusBetween(String value1, String value2) {
            addCriterion("v_cf_status between", value1, value2, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVCfStatusNotBetween(String value1, String value2) {
            addCriterion("v_cf_status not between", value1, value2, "vCfStatus");
            return (Criteria) this;
        }

        public Criteria andVRemarkIsNull() {
            addCriterion("v_remark is null");
            return (Criteria) this;
        }

        public Criteria andVRemarkIsNotNull() {
            addCriterion("v_remark is not null");
            return (Criteria) this;
        }

        public Criteria andVRemarkEqualTo(String value) {
            addCriterion("v_remark =", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotEqualTo(String value) {
            addCriterion("v_remark <>", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkGreaterThan(String value) {
            addCriterion("v_remark >", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("v_remark >=", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLessThan(String value) {
            addCriterion("v_remark <", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLessThanOrEqualTo(String value) {
            addCriterion("v_remark <=", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLike(String value) {
            addCriterion("v_remark like", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotLike(String value) {
            addCriterion("v_remark not like", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkIn(List<String> values) {
            addCriterion("v_remark in", values, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotIn(List<String> values) {
            addCriterion("v_remark not in", values, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkBetween(String value1, String value2) {
            addCriterion("v_remark between", value1, value2, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotBetween(String value1, String value2) {
            addCriterion("v_remark not between", value1, value2, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdIsNull() {
            addCriterion("v_keeper_id is null");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdIsNotNull() {
            addCriterion("v_keeper_id is not null");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdEqualTo(String value) {
            addCriterion("v_keeper_id =", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdNotEqualTo(String value) {
            addCriterion("v_keeper_id <>", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdGreaterThan(String value) {
            addCriterion("v_keeper_id >", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdGreaterThanOrEqualTo(String value) {
            addCriterion("v_keeper_id >=", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdLessThan(String value) {
            addCriterion("v_keeper_id <", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdLessThanOrEqualTo(String value) {
            addCriterion("v_keeper_id <=", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdLike(String value) {
            addCriterion("v_keeper_id like", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdNotLike(String value) {
            addCriterion("v_keeper_id not like", value, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdIn(List<String> values) {
            addCriterion("v_keeper_id in", values, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdNotIn(List<String> values) {
            addCriterion("v_keeper_id not in", values, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdBetween(String value1, String value2) {
            addCriterion("v_keeper_id between", value1, value2, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andVKeeperIdNotBetween(String value1, String value2) {
            addCriterion("v_keeper_id not between", value1, value2, "vKeeperId");
            return (Criteria) this;
        }

        public Criteria andDuiliangHIsNull() {
            addCriterion("duiliang_h is null");
            return (Criteria) this;
        }

        public Criteria andDuiliangHIsNotNull() {
            addCriterion("duiliang_h is not null");
            return (Criteria) this;
        }

        public Criteria andDuiliangHEqualTo(String value) {
            addCriterion("duiliang_h =", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHNotEqualTo(String value) {
            addCriterion("duiliang_h <>", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHGreaterThan(String value) {
            addCriterion("duiliang_h >", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHGreaterThanOrEqualTo(String value) {
            addCriterion("duiliang_h >=", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHLessThan(String value) {
            addCriterion("duiliang_h <", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHLessThanOrEqualTo(String value) {
            addCriterion("duiliang_h <=", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHLike(String value) {
            addCriterion("duiliang_h like", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHNotLike(String value) {
            addCriterion("duiliang_h not like", value, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHIn(List<String> values) {
            addCriterion("duiliang_h in", values, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHNotIn(List<String> values) {
            addCriterion("duiliang_h not in", values, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHBetween(String value1, String value2) {
            addCriterion("duiliang_h between", value1, value2, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andDuiliangHNotBetween(String value1, String value2) {
            addCriterion("duiliang_h not between", value1, value2, "duiliangH");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceIsNull() {
            addCriterion("isshuliangjiace is null");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceIsNotNull() {
            addCriterion("isshuliangjiace is not null");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceEqualTo(Integer value) {
            addCriterion("isshuliangjiace =", value, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceNotEqualTo(Integer value) {
            addCriterion("isshuliangjiace <>", value, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceGreaterThan(Integer value) {
            addCriterion("isshuliangjiace >", value, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceGreaterThanOrEqualTo(Integer value) {
            addCriterion("isshuliangjiace >=", value, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceLessThan(Integer value) {
            addCriterion("isshuliangjiace <", value, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceLessThanOrEqualTo(Integer value) {
            addCriterion("isshuliangjiace <=", value, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceIn(List<Integer> values) {
            addCriterion("isshuliangjiace in", values, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceNotIn(List<Integer> values) {
            addCriterion("isshuliangjiace not in", values, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceBetween(Integer value1, Integer value2) {
            addCriterion("isshuliangjiace between", value1, value2, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsshuliangjiaceNotBetween(Integer value1, Integer value2) {
            addCriterion("isshuliangjiace not between", value1, value2, "isshuliangjiace");
            return (Criteria) this;
        }

        public Criteria andIsInCheckIsNull() {
            addCriterion("is_in_check is null");
            return (Criteria) this;
        }

        public Criteria andIsInCheckIsNotNull() {
            addCriterion("is_in_check is not null");
            return (Criteria) this;
        }

        public Criteria andIsInCheckEqualTo(Integer value) {
            addCriterion("is_in_check =", value, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckNotEqualTo(Integer value) {
            addCriterion("is_in_check <>", value, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckGreaterThan(Integer value) {
            addCriterion("is_in_check >", value, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_in_check >=", value, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckLessThan(Integer value) {
            addCriterion("is_in_check <", value, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckLessThanOrEqualTo(Integer value) {
            addCriterion("is_in_check <=", value, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckIn(List<Integer> values) {
            addCriterion("is_in_check in", values, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckNotIn(List<Integer> values) {
            addCriterion("is_in_check not in", values, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckBetween(Integer value1, Integer value2) {
            addCriterion("is_in_check between", value1, value2, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andIsInCheckNotBetween(Integer value1, Integer value2) {
            addCriterion("is_in_check not between", value1, value2, "isInCheck");
            return (Criteria) this;
        }

        public Criteria andCheckModeIsNull() {
            addCriterion("check_mode is null");
            return (Criteria) this;
        }

        public Criteria andCheckModeIsNotNull() {
            addCriterion("check_mode is not null");
            return (Criteria) this;
        }

        public Criteria andCheckModeEqualTo(String value) {
            addCriterion("check_mode =", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeNotEqualTo(String value) {
            addCriterion("check_mode <>", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeGreaterThan(String value) {
            addCriterion("check_mode >", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeGreaterThanOrEqualTo(String value) {
            addCriterion("check_mode >=", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeLessThan(String value) {
            addCriterion("check_mode <", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeLessThanOrEqualTo(String value) {
            addCriterion("check_mode <=", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeLike(String value) {
            addCriterion("check_mode like", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeNotLike(String value) {
            addCriterion("check_mode not like", value, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeIn(List<String> values) {
            addCriterion("check_mode in", values, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeNotIn(List<String> values) {
            addCriterion("check_mode not in", values, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeBetween(String value1, String value2) {
            addCriterion("check_mode between", value1, value2, "checkMode");
            return (Criteria) this;
        }

        public Criteria andCheckModeNotBetween(String value1, String value2) {
            addCriterion("check_mode not between", value1, value2, "checkMode");
            return (Criteria) this;
        }

        public Criteria andIsWzcIsNull() {
            addCriterion("is_wzc is null");
            return (Criteria) this;
        }

        public Criteria andIsWzcIsNotNull() {
            addCriterion("is_wzc is not null");
            return (Criteria) this;
        }

        public Criteria andIsWzcEqualTo(String value) {
            addCriterion("is_wzc =", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcNotEqualTo(String value) {
            addCriterion("is_wzc <>", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcGreaterThan(String value) {
            addCriterion("is_wzc >", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcGreaterThanOrEqualTo(String value) {
            addCriterion("is_wzc >=", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcLessThan(String value) {
            addCriterion("is_wzc <", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcLessThanOrEqualTo(String value) {
            addCriterion("is_wzc <=", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcLike(String value) {
            addCriterion("is_wzc like", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcNotLike(String value) {
            addCriterion("is_wzc not like", value, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcIn(List<String> values) {
            addCriterion("is_wzc in", values, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcNotIn(List<String> values) {
            addCriterion("is_wzc not in", values, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcBetween(String value1, String value2) {
            addCriterion("is_wzc between", value1, value2, "isWzc");
            return (Criteria) this;
        }

        public Criteria andIsWzcNotBetween(String value1, String value2) {
            addCriterion("is_wzc not between", value1, value2, "isWzc");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("type is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("type is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(String value) {
            addCriterion("type =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(String value) {
            addCriterion("type <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(String value) {
            addCriterion("type >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(String value) {
            addCriterion("type >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(String value) {
            addCriterion("type <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(String value) {
            addCriterion("type <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLike(String value) {
            addCriterion("type like", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotLike(String value) {
            addCriterion("type not like", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<String> values) {
            addCriterion("type in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<String> values) {
            addCriterion("type not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(String value1, String value2) {
            addCriterion("type between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(String value1, String value2) {
            addCriterion("type not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }
    }

    /**
     * t_warehouse
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_warehouse 2018-12-14
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}